
//------------------------test variables--------------------------;
unsigned int frame_stat=0;
unsigned int bad_block_count=0;
unsigned char bad_block_type_flag=0;
int big_value_0_count=0;
int big_value_1_count=0;
long int block_type_0_count=0;
//char window_switching_flag_test=0;

//-------------------------Bitrate_table------------------------;
unsigned int bitrate_table[2][4][16]=
{
{
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},//blank for 1,0,0
{0,32,48,56,64,80,96,112,128,144,160,176,192,224,256,0},//table for 1,3,0
{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,0},//table for 1,2,0
{0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,0}//table for 1,1,0
},

{
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},//blank for 0,0,0
{0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,0},//table for 0,1,0
{0,32,48,56,64,80,96,112,128,160,192,224,256,320,384,0},//table for 0,2,0
{0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,0}//table for 0,3,0
}
};
//Note:
//first index refers to MPEG version. 1 -> MPEG1, 0 -> MPEG2 .Agree with definition in frame header
//Second index refers to layer number. Agree with definition in frame header.01->layer3,10->layer2,11->layer1.
//Third refers to birate index.
/*birate[0][1][]={0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,0}//layer 3, MPEG 1
birate[0][2][]={0,32,48,56,64,80,96,112,128,160,192,224,256,320,384,0}//layer 2, MPEG 1
birate[0][3][]={0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,0}//layer1, MPEG 1
birate[1][1,2][]={0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,0}//layer 3 & layer 2, MPEG2
birate[1][3][]={0,32,48,56,64,80,96,112,128,144,160,176,192,224,256,0}//Mpeg 2 layer 1
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}<-This is for blank table*/


//-------------------------Sample_rate_table-------------------------;
unsigned int sample_rate_table[3][4]=
{
{22050,24000,16000,0},
{44100,48000,32000,0},
{11025,12000,8000,0}
};
//Note:1.first index refers to MPEG version. 1 -> MPEG1, 0 -> MPEG2, 3 -> MPEG2.5
/*sample_rate_table[0]={44100,48000,32000,0};//MPEG1
sample_rate_table[1]={22050,24000,16000,0};//MPEG2
sample_rate_table[1]={11025,12000,8000,0};//MPEG2.5*/


/**********************Function:Header_Reader Definition Starts**************************/
/**Function Parameter Distription:"Index" is a pointer refering the position from which the function starts to search for syscword."FrameCount" is used to document the number of frames in the fils."*header_info" and "*si" is a pointer used by the function to documnent the header infomation and side infomation.Finally, when the function is finished, the location  of the starting point of main data is stored in "*main_data_bs"**/
/**Function Return Distription: This function return a parameter that tells the location of next frame.This location is caculated based on the infomarion found in the header**/

 header_reader(unsigned char **index,
		     unsigned long int *sycnword_count,
		     header_info_type *header_info,
		     side_info_type *si_current,
		     side_info_type *si_previous,
		     bit_stream_struc *main_data_beg_bs,
		     unsigned char *valid)
{
	 int ch, gr, i;
	 unsigned char *starting_index;//this variable is used to locate the postition of syncword in the current frame
	 unsigned char *side_info_start_ptr;
	 unsigned char position_flag=0;//if 0, indicating the sync_word is in forms of "0x*F 0xFF".Else in the form of"0xFF 0xF*"
                              // ^-starting index              ^-start idx
	 unsigned char flag=0;
	 bit_stream_struc bs;

/**************************************Start anaylzing header***********************************/
    while(!flag)
    {
    	if((**index)==0xff)
    	{
    		if(((*(*index-1))&0x0f)==0x0f)
    		{
    			flag=1;
    			starting_index=*index-1;
    			position_flag=0;
    		}
    		if(((*(*index+1))&0xf0)==0xf0)
    		{
    			flag=1;
    			starting_index=*index;
    			position_flag=1;
    		}
    	}
    	(*index)++;
     }
	 (*index)--;
	 (*sycnword_count)++;
	 //printf("\nI find the %dst syncword offset is at %d, position_flag is %d.\n",
		//*sycnword_count,(unsigned int)(starting_index-data_header),position_flag);
	 if(position_flag==0)
	 {
		 bs.byte_idx_ptr=starting_index+2;
		 bs.bit_idx=7;
		 //printf("bs.byte_idx_ptr now is %d",bs.byte_idx_ptr-data_header);
	 }
	 else
	 {
		 bs.byte_idx_ptr=starting_index+1;
		 //printf("bs.byte_idx_ptr now is %d",bs.byte_idx_ptr-data_header);
		 bs.bit_idx=3;
	 }
	 header_info->ID = getbits(&bs,1);
	 header_info->layer = 4-getbits(&bs,2);
	 header_info->protection_bit = !get1bit(&bs); /* error protect. TRUE/FALSE */
	 header_info->bitrate_index = getbits(&bs,4);
	 header_info->sampling_frequency_index = getbits(&bs,2);
	 header_info->pading_bit = get1bit(&bs);
	 header_info->private_bit = get1bit(&bs);
	 header_info->mode = getbits(&bs,2);
	 header_info->mode_extension = getbits(&bs,2);
	 header_info->copy_right = get1bit(&bs);
	 header_info->original_home = get1bit(&bs);
	 header_info->emphasis = getbits(&bs,2);

	 if(header_info->protection_bit==0)
		 side_info_start_ptr=starting_index+4;
	 else
		 side_info_start_ptr=starting_index+6;
	 //printf("side_info_start_ptr is now %d",side_info_start_ptr-data_header);

	 if(sample_rate_table[header_info->ID][header_info->sampling_frequency_index])
	 {
		 header_info->frame_length=144*1000*bitrate_table[header_info->ID][header_info->layer][header_info->bitrate_index]/sample_rate_table[header_info->ID][header_info->sampling_frequency_index]+header_info->pading_bit;
	 }
	 else header_info->frame_length=0;
	 if((sample_rate_table[header_info->ID][header_info->sampling_frequency_index]==44100)
			 &&(bitrate_table[header_info->ID][header_info->layer][header_info->bitrate_index]==320)
			 &&(header_info->ID)
			 &&(header_info->layer==3))
	 {*valid=1;}
	 else
	 {*valid=0;goto LP;}
/**************************************end of anaylzing header***********************************/

//*************************************Start Analyzing Side Info****************************//
   bs.byte_idx_ptr=side_info_start_ptr;
   stereo = (header_info->mode==0x3)?1:2;
   if(position_flag==0)
	{bs.bit_idx=3;}
   else{bs.bit_idx=7;}
   if(header_info->ID == 1)
   {
	   si_current->main_data_end = getbits(&bs, 9);
      if (stereo == 1)
    	  si_current->private_bits = getbits(&bs,5);
         else si_current->private_bits = getbits(&bs,3);

       for (ch=0; ch<stereo; ch++)
           for (i=0; i<4; i++)
        	   si_current->ch[ch].scfsi[i] = getbits(&bs,1);


        for (gr=0; gr< grNum ; gr++) {
           for (ch=0; ch<stereo; ch++) {
        	   si_current->ch[ch].gr[gr].part2_3_length = getbits(&bs, 12);
        	   si_current->ch[ch].gr[gr].big_values = getbits(&bs, 9);
        	   si_current->ch[ch].gr[gr].global_gain = getbits(&bs, 8);
        	   si_current->ch[ch].gr[gr].scalefac_compress = getbits(&bs, 4);
        	   si_current->ch[ch].gr[gr].window_switching_flag = getbits(&bs,1);
              if (si_current->ch[ch].gr[gr].window_switching_flag) {//window_switching_flag_test=1;//test;
            	  si_current->ch[ch].gr[gr].block_type = getbits(&bs, 2);
            	  si_current->ch[ch].gr[gr].mixed_block_flag = getbits(&bs,1);
                 for (i=0; i<2; i++)
                	 si_current->ch[ch].gr[gr].table_select[i] = getbits(&bs, 5);
                 for (i=0; i<3; i++)
                	 si_current->ch[ch].gr[gr].subblock_gain[i] = getbits(&bs, 3);

            /* Set region_count parameters since they are implicit in this case. */

                 if (si_current->ch[ch].gr[gr].block_type == 0) {
                   printf("Side info bad: block_type == 0 in split block.\n");
		   	bad_block_count++;//test;
		   	exit(0);
			goto LP;
                 }
                 else if (si_current->ch[ch].gr[gr].block_type == 2
                      && si_current->ch[ch].gr[gr].mixed_block_flag == 0)
                	 si_current->ch[ch].gr[gr].region0_count = 8; /* MI 9; */
                 else si_current->ch[ch].gr[gr].region0_count = 7; /* MI 8; */
                 si_current->ch[ch].gr[gr].region1_count = 20 -
                		 si_current->ch[ch].gr[gr].region0_count;
             }
            else {
               for (i=0; i<3; i++)
            	   si_current->ch[ch].gr[gr].table_select[i] = getbits(&bs, 5);
               si_current->ch[ch].gr[gr].region0_count = getbits(&bs, 4);
               si_current->ch[ch].gr[gr].region1_count = getbits(&bs, 3);
               si_current->ch[ch].gr[gr].block_type = 0;
            }
              si_current->ch[ch].gr[gr].preflag = getbits(&bs,1);
              si_current->ch[ch].gr[gr].scalefac_scale = getbits(&bs,1);
              si_current->ch[ch].gr[gr].count1table_select = getbits(&bs,1);
         }
      }
    }
    else /* Layer 3 LSF */
    {
        exit(0);
  }

if(si_previous->main_data_end==0)
{main_data_beg_bs->bit_idx=bs.bit_idx;
main_data_beg_bs->byte_idx_ptr=bs.byte_idx_ptr;}
else
{main_data_beg_bs->bit_idx=7;
main_data_beg_bs->byte_idx_ptr=starting_index-(si_previous->main_data_end)+1;}
//*************************************End Analyzing Side Info****************************//
/*if((si->ch[ch].gr[gr].block_type != 0)
	(sample_rate_table[header_info->ID][header_info->sampling_frequency_index]==44100)
	&&(bitrate_table[header_info->ID][header_info->layer][header_info->bitrate_index]==192)
	&&(!si->main_data_begin)
	&&(frame_length==522)
	&&(!header_info->ID)
	&&(header_info->layer==3)
	&&(si->main_data_begin==0))*/
	{frame_stat++;//test;
//************************************Start printing the header information*********************//
/*if(sample_rate_table[header_info->ID][header_info->sampling_frequency_index])
{printf("frame_length is %d\n",header_info->frame_length);}
else
{printf("Sampling freq is 0.\n");goto LP;}
printf("Header information as follows:\n");
printf("ID is 0x%x ",header_info->ID);
if(header_info->layer) printf("layeris 0x%x ",header_info->layer); else printf("Wrong layer number! ");
printf("protection_bit is 0x%x  ",header_info->protection_bit);
printf("bitrate_index is 0x%x,bitrate is %d ", header_info->bitrate_index, bitrate_table[header_info->ID][header_info->layer][header_info->bitrate_index]);
printf("sampling_freq_index is 0x%x,sampling_frequency is %d ",header_info->sampling_frequency_index, sample_rate_table[header_info->ID][header_info->sampling_frequency_index]);
printf("pading_bit is 0x%x ",header_info->pading_bit);
printf("private_bit is 0x%x ",header_info->private_bit);
printf("mode index is 0x%x, ",header_info->mode);
if(header_info->mode==3) printf("Single Channel.SideInfo is 17 bits. ");
else if(header_info->mode==2) printf("Dual Channel. SideInfo is 32 bits. ");
else if(header_info->mode==1) printf("Joint Stero Mode. ");
else if(header_info->mode==0) printf("Stero Mode. ");
printf("mode_extension is 0x%x ",header_info->mode_extension);
printf("copy_right is 0x%x ",header_info->copy_right);
printf("original_home is 0x%x ",header_info->original_home);
printf("emphasis is 0x%x \n",header_info->emphasis);*/
//************************************End of printing the header information*********************//

//*************************************Start of printing Side Info****************************//
/*
printf("Side Information as follows:\n");
printf("Main_data_End:%d  ",si_current->main_data_end);
printf("Main_data_begin:%d  ",main_data_beg_bs->byte_idx_ptr-data_header);
printf("Private_bits:%d  ",si_current->private_bits);
for (ch=0; ch<stereo; ch++)
           for (i=0; i<4; i++)
           printf("channel[%d],scfsi[%d] is:%d  ",ch,i,si_current->ch[ch].scfsi[i]);printf("\n");
for (gr=0; gr< grNum ; gr++) {
           for (ch=0; ch<stereo; ch++) {
	      printf("Info of Granul %d,channel %d is as following:  ",gr,ch);
              printf("part2_3_length:%d   ",si_current->ch[ch].gr[gr].part2_3_length);
              printf("big_values:%d  ",si_current->ch[ch].gr[gr].big_values);
		if(si_current->ch[ch].gr[gr].big_values!=0) big_value_1_count++; else big_value_0_count++;
	      printf("global_gain:%d  ",si_current->ch[ch].gr[gr].global_gain);
	      printf("scalefac_compress:%d  ",si_current->ch[ch].gr[gr].scalefac_compress);
	      printf("window_switching_flag:%d  ",si_current->ch[ch].gr[gr].window_switching_flag);
              if (si_current->ch[ch].gr[gr].window_switching_flag) {
                 printf("block_type:0x%x  ",si_current->ch[ch].gr[gr].block_type);
                 if((si_current->ch[ch].gr[gr].block_type)==0) {block_type_0_count++;
                 printf("mixed_block_flag:0x%x  ",si_current->ch[ch].gr[gr].mixed_block_flag);
                 for (i=0; i<2; i++)
                    printf("table_select [%d]:%d  ",i,si_current->ch[ch].gr[gr].table_select[i]);
                 for (i=0; i<3; i++)
		    printf("subblock_gain [%d]:%d  ",i,si_current->ch[ch].gr[gr].subblock_gain[i]);
            printf("region0_count:%d  ",si_current->ch[ch].gr[gr].region0_count);
	         printf("region1_count:%d  ",si_current->ch[ch].gr[gr].region1_count);
              }
              else {
                for (i=0; i<3; i++)
               printf("table_select [%d]:%d  ",i,si_current->ch[ch].gr[gr].table_select[i]);
               printf("region0_count:%d  ",si_current->ch[ch].gr[gr].region0_count);
	           printf("region1_count:%d  ",si_current->ch[ch].gr[gr].region1_count);
               printf("block_type:0x%x  ",si_current->ch[ch].gr[gr].block_type);
               if((si_current->ch[ch].gr[gr].block_type)==0) block_type_0_count++;//test;
              }
	 printf("scalefac_scale:%d  ",si_current->ch[ch].gr[gr].scalefac_scale);
	 printf("count1table_select:%d\n",si_current->ch[ch].gr[gr].count1table_select );
         }
     }*/
     //printf("\n");
//*************************************End of printing Side Info****************************//
}
LP:;
if(header_info->frame_length)
*index=*index+header_info->frame_length;
else *index=*index+1;
//printf("\nindex now is %d\n",*index-data_header);
//printf("I do return!!\n");
//returning the position of next frame

}
/******************************Header_Reader Definition Ends**************************/

/******************************Function:Find_the_first_frame**************************/
/**input:address of data_header**************************/
/**output:address of the first frame, the syncword offset of this frame,*********************************/
void find_the_first_frame
		(unsigned char **address_of_first_frame,
		unsigned long int *sycnword_count)
{
	unsigned char *index=&data_header;
	unsigned char *prvious_frame_index;
	unsigned char *first_frame_index=0;
	unsigned char valid[2]={0,0};
	unsigned char first_time_valid=0;
	unsigned char i=0;
	bit_stream_struc main_data_bs[2];
	header_info_type header_info[2];
	side_info_type si[2];
	header_info[0].frame_length=0;
	header_info[1].frame_length=0;
	for(;;)
	{
		prvious_frame_index=index-header_info[i].frame_length;
		i++;
		if(i>1) i=0;
		header_reader(&index,sycnword_count,&header_info[i],&si[1],&si[0],&main_data_bs[i],&valid[i]);
		if((!first_time_valid)&&(valid[1])&&(valid[0]))
		{
			first_frame_index=prvious_frame_index;
			(*address_of_first_frame)=first_frame_index;
			first_time_valid=1;
			//printf("First frame found.\n");
			//printf("address_of_first_frame is %d\n",*address_of_first_frame-data_header);
			return;
		}
	}
}
