#include "dewindowarray.h"
#include "syn_costable.h"
#define SCALE 32768

inline void create_syn_filter(double doublefilter[64][SBLIMIT]) {
	register int i, k;

	for (i = 0; i < 64; i++)
		for (k = 0; k < 32; k++) {
			//if ((filter[i][k] = 1e9*cos((float)((PI/64*i+PI/4)*(2*k+1)))) >= 0)
			if ((doublefilter[i][k] = syn_costable[(i << 5) + k]) >= 0)
				modf(doublefilter[i][k] + 0.5, &doublefilter[i][k]);
			else
				modf(doublefilter[i][k] - 0.5, &doublefilter[i][k]);

			//printf("filter  before is %.16f\n",filter[i][k]);
			doublefilter[i][k] *= 1e-9;
			//printf("syn_costable[(i<<5)+k] is %.16f\n",syn_costable[(i<<5)+k]);
			//printf("filter after is %.16f\n", doublefilter[i][k]);
		}

}

inline void SubBandSynthesis(float *bandPtr, int ch, short *samples) {
	register int i, j, k;
	int iii, jjj;
	register float *bufOffsetPtr, sum;
	register long foo;
	static int init = 1;
	typedef float NN[64][32];
	typedef double MM[64][32];
	static NN *filter;
	static MM *doublefilter;
	typedef float BB[2][1024];
	static BB *buf;
	static int bufOffset[2] = { 64, 64 };
	if (init) {
		buf = (BB *) malloc(sizeof(BB));
		doublefilter = (MM *) malloc(sizeof(MM));
		filter = (NN *) malloc(sizeof(NN));
		create_syn_filter(*doublefilter);
		for (iii = 0; iii < 64; iii++) {
			for (jjj = 0; jjj < 32; jjj++)
				(*filter)[iii][jjj] = (float) (*doublefilter)[iii][jjj];
			;
		}

		init = 0;
	}

	bufOffset[ch] = (bufOffset[ch] - 64) & 0x3ff;
	bufOffsetPtr = &((*buf)[ch][bufOffset[ch]]);

	for (i = 0; i < 64; i++) {
		sum = 0;
		for (k = 0; k < 32; k++)
			sum += bandPtr[k] * (*filter)[i][k];
		bufOffsetPtr[i] = sum;
	}

	for (j = 0; j < 32; j++) {
		sum = 0;
		for (i = 0; i < 16; i++) {
			k = j + (i << 5);
			sum += dewindow[k] * (*buf)[ch][((k + (((i + 1) >> 1) << 6))
					+ bufOffset[ch]) & 0x3ff];
		}

		if (sum > 0) {
			foo = (long) (sum * (float) SCALE + (float) 0.5);
		} else {
			foo = (long) (sum * (float) SCALE - (float) 0.5);
		}

		if (foo >= (long) SCALE) {
			samples[j] = (short) (SCALE - 1);
		} else if (foo < (long) -SCALE) {
			samples[j] = (short) (-SCALE);
		} else
			samples[j] = (short) foo;
            
       //pcm_output[frameNum-1][gr_global][ch_global][ss_global][j]=samples[j];
	}
}
